%define name		tinderbox
%define version		2.0
%define snapshot	20060524
%define release		%mkrel 0.%{snapshot}.4

%define _provides_exceptions perl(.*)
%define _requires_exceptions perl(\\(CGI.pl\\|Utils\\|Tinder.*\\|BTData\\|BonsaiData\\|BuildStatus\\|Error_Parse\\|FileStructure\\|HTMLPopUp\\|Persistence\\|MailProcess\\|ReqData\\|Summaries\\|TreeData\\|PVCSGetData\\|VCDisplay\\))

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	Development Monitoring Tool
License:	MPL
Group:		Networking/WWW
URL:		http://www.mozilla.org/projects/tinderbox
Source0:	%{name}-%{snapshot}.tar.bz2
Source1:	%{name}.init
Patch0:		%{name}-20060524.fhs.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}

%description
Tinderbox is the first program to allow developers and management to
see at a glance what is currently going on in all aspects of the
development process. The Tinderbox server prepares HTML pages which
display the history of many different development variables. It shows
at a glance the history of: whether the HEAD branch of the source code
builds and passes all automated tests, who has checked code changes
into the version control system, whether the source tree is open or
closed and when the state of the tree last changed, what trouble
tickets have been closed, notices and messages posted by the
developers or project manager.

%package server
Summary:	Tinderbox web application
Group:		Networking/WWW
Requires:	%{name} = %{version}
# webapp macros and scriptlets
Requires(post):		rpm-helper >= 0.16
Requires(postun):	rpm-helper >= 0.16
BuildRequires:	rpm-helper >= 0.16
BuildRequires:	rpm-mandriva-setup >= 1.23

%description server
This package contains the Tinderbox web application.

%package client
Summary:	Tinderbox build bot
Group:		Networking/WWW
Requires:	%{name} = %{version}
Requires(pre):	rpm-helper
Requires(post):	rpm-helper

%description client
This package contains the Tinderbox build bot.

%prep
%setup -q -n %{name}2
%patch0 -p1

# useless binaries
rm -f ./src/bin/bustagestats.cgi ./src/bin/gifsize

%build
./configure --prefix=%{_prefix} \
	    --cgibin-prefix=%{_var}/www/%{name}
make

%install
rm -rf %{buildroot}

install -d -m 755 %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/bin/processmail_* %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/bin/rmlogs %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/clientbin/binary_runs %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/clientbin/build_shellscript %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/clientbin/cull_archive_dirs %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/clientbin/HTTPPost %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/clientbin/ignore_waitstatus %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/clientbin/show_env %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/clientbin/show_time %{buildroot}%{_datadir}/%{name}/bin
install -m 755 build/clientbin/test_return %{buildroot}%{_datadir}/%{name}/bin
cp -pr build/lib %{buildroot}%{_datadir}/%{name}
cp -pr build/bonsai_p4db %{buildroot}%{_datadir}/%{name}
cp -pr build/bonsai_pvcs %{buildroot}%{_datadir}/%{name}

install -d -m 755 %{buildroot}%{_var}/www/%{name}
install -m 755 build/bin/*.cgi %{buildroot}%{_var}/www/%{name}
install -m 644 src/gif/*.gif %{buildroot}%{_var}/www/%{name}

install -d -m 755 %{buildroot}%{_sysconfdir}/%{name}
install -m 644 build/default_conf/*.pm %{buildroot}%{_sysconfdir}/%{name}
install -m 644 build/clientbin/generic.sample.buildcf %{buildroot}%{_sysconfdir}/%{name}/buildcf

install -d -m 755 %{buildroot}%{_initrddir}
install -m 755 %{SOURCE1} %{buildroot}%{_initrddir}/%{name}
install -d -m 755 %{buildroot}%{_sysconfdir}/default

install -d -m 755 %{buildroot}%{_localstatedir}/lib/%{name}/{html,data}
install -d -m 755 %{buildroot}%{_var}/cache/%{name}
install -d -m 755 %{buildroot}%{_var}/log/%{name}

# clean out doc files
rm -f %{buildroot}%{_datadir}/%{name}/lib/README
mv build/lib/README README.lib 
mv build/bin/README README.bin
mv build/clientbin/README README.clientbin
chmod 644 README.clientbin README.bin

# apache configuration
install -d -m 755 %{buildroot}%{_webappconfdir}
cat > %{buildroot}%{_webappconfdir}/%{name}.conf <<EOF
# %{name} Apache configuration
Alias /%{name}/html %{_localstatedir}/lib/%{name}/html
Alias /%{name} %{_var}/www/%{name}

<Directory %{_var}/www/%{name}>
    Options ExecCGI
    DirectoryIndex tinder.cgi
    Allow from all
</Directory>

<Directory %{_localstatedir}/lib/%{name}/html>
    Allow from all
</Directory>
EOF

# init script configuration
install -d -m 755 %{buildroot}%{_sysconfdir}/sysconfdir
cat > %{buildroot}%{_sysconfdir}/sysconfdir/%{name} <<EOF
# %{name} build bot service configuration
BUILD=
TREE=
EOF

cat > README.mdv <<EOF
Mandriva RPM specific notes

setup
-----
The setup used here differs from default one, to achieve better FHS compliance.
- the static files accessibles from the web are in %{_var}/www/%{name}
- the generated files are in %{_localstatedir}/lib/%{name}
- the files non accessibles from the web are in %{_datadir}/%{name}
- the configuration file will be generated in %{_sysconfdir}/%{name}

post-installation
-----------------
you have to configure either STMP or HTTP build log transfer from build hosts
to the web host.

EOF

%clean
rm -rf %{buildroot}

%post
if [ $1 = 1 ]; then
    perl -pi \
	-e 's/^(\$TINDERBOX_UID=).*/$1 . getpwnam("apache") . ";"/e;' \
	-e 's/^(\$TINDERBOX_GID=).*/$1 . getgrnam("apache") . ";"/e;' \
	%{_sysconfdir}/%{name}/TinderConfig.pm
fi

%post server
%_post_webapp
if [ $1 = 1 ]; then
    %create_ghostfile %{_var}/log/%{name}/tinderbox.log apache apache 640
fi

%postun server
%_postun_webapp

%pre client
%_pre_useradd %{name} %{_var}/cache/%{name} /bin/sh

%post client
%_post_service %{name}
if [ $1 = 1 ]; then
    %create_ghostfile %{_var}/log/%{name}/build.log tinderbox tinderbox 640
fi

%preun client
%_preun_service %{name}

%postun client
%_postun_userdel %{name}

%files
%defattr(-,root,root)
%doc README README.mdv README.NETSCAPE_PROCESS README.TESTING_IDEAS
%doc ChangeLog Contact Goals Install Overview Policies ReleaseNotes
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/TreeData.pm
%config(noreplace) %{_sysconfdir}/%{name}/TinderConfig.pm
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/bin
%dir %{_var}/log/%{name}

%files server
%defattr(-,root,root)
%doc README.lib README.bin 
%config(noreplace) %{_webappconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/BTData.pm
%config(noreplace) %{_sysconfdir}/%{name}/BuildStatus.pm
%config(noreplace) %{_sysconfdir}/%{name}/Error_Parse.pm
%config(noreplace) %{_sysconfdir}/%{name}/ReqData.pm
%config(noreplace) %{_sysconfdir}/%{name}/FileStructure.pm
%{_var}/www/%{name}
%{_datadir}/%{name}/bin/processmail_*
%{_datadir}/%{name}/bin/rmlogs
%{_datadir}/%{name}/lib
%{_datadir}/%{name}/bonsai_p4db
%{_datadir}/%{name}/bonsai_pvcs
%attr(-,apache,apache) %{_localstatedir}/lib/%{name}

%files client
%defattr(-,root,root)
%doc README.clientbin
%config(noreplace) %{_sysconfdir}/%{name}/buildcf
%config(noreplace) %{_sysconfdir}/sysconfdir/%{name}
%{_initrddir}/%{name}
%{_datadir}/%{name}/bin/binary_runs
%{_datadir}/%{name}/bin/build_shellscript
%{_datadir}/%{name}/bin/cull_archive_dirs
%{_datadir}/%{name}/bin/HTTPPost
%{_datadir}/%{name}/bin/ignore_waitstatus
%{_datadir}/%{name}/bin/show_env
%{_datadir}/%{name}/bin/show_time
%{_datadir}/%{name}/bin/test_return
%attr(-,tinderbox,tinderbox) %{_var}/cache/%{name}



%changelog
* Mon Jun 02 2008 Pixel <pixel@mandriva.com> 2.0-0.20060524.4mdv2009.0
+ Revision: 214231
- adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Mon Dec 17 2007 Thierry Vignaud <tvignaud@mandriva.com> 2.0-0.20060524.4mdv2008.1
+ Revision: 128459
- kill re-definition of %%buildroot on Pixel's request
- import tinderbox


* Fri Jun 30 2006 Guillaume Rousse <guillomovitch@mandriva.org> 2.0-0.20060524.4mdv2007.0
- relax buildrequires versionning

* Mon Jun 26 2006 Guillaume Rousse <guillomovitch@mandriva.org> 2.0-0.20060524.3mdv2007.0
- new webapp macros

* Thu Jun 15 2006 Guillaume Rousse <guillomovitch@mandriva.org> 2.0-0.20060524.2mdv2007.0
- init script configuration belongs to %%{_sysconfdir}/sysconfdir, not %%{_sysconfdir}/default
- use client/server names for subpackage
- decompress patch
- don't provides dependencies for private perl modules

* Wed Jun 14 2006 Guillaume Rousse <guillomovitch@mandriva.org> 2.0-0.20060524.1mdv2007.0
- first mdv release 
